import os
import sys
import commands

amc = "/opt/amc/server"
site_packages = "%s/site-packages" % amc
pycrypto_setup = "%s/setups/pycrypto" % amc
sys.path.insert(1,'%s/' % site_packages)

def can_import_pycrypto():

    try:
        from Crypto.Cipher import AES
    except:
        return 0
    return 1

def generate_pycrypto():

    try:
        sys.stderr.write("installing pycryto\n")
        sys.stderr.write("You may check pycrypto compilation output in /tmp/pycrypto.log and delete it if all is OK\n")
        exit_status = os.system("export ac_cv_func_malloc_0_nonnull=yes")
        if exit_status == 0:
            os.chdir("%s" % pycrypto_setup)
            exit_status, output = commands.getstatusoutput("tar -xvf pycrypto-2.6.1.tar.gz")
            if exit_status != 0:
                return 0
            os.chdir("pycrypto-2.6.1")
            exit_status, output = commands.getstatusoutput("python setup.py build && python setup.py install --home=%s --install-lib=%s" % (site_packages, site_packages))
        else:
            return 0
        f = open('/tmp/pycrypto.log', 'w')
        f.write(output)
        f.close()

        if exit_status != 0:
            sys.stderr.write("AMC dependency not met. Please install gcc, python-dev and libgmp-dev (for Debian/Ubuntu) or python-devel and gmp-devel (for CentOS/RedHatLinux) before installing AMC.\n")
            return 0
        if can_import_pycrypto():
            return 1
        else:
            return 0
    except:
        return 0

